#include "module.h"

#define AUTHOR "Vorex"
#define VERSION "0.1"

int my_privmsg(char *source, int ac, char **av);
CommandHash *loveserv_cmdTable[MAX_CMD_HASH];

void addClient(char *nick, char *realname);
void addMessageList(void);
void delClient(void);
char *s_loveserv = "LoveServ";
void loveserv(User * u, char *buf);


/* Commands */
int do_help(User *u);
int do_kiss(User *u);
int do_rose(User *u);
int do_about(User *u);
int do_version(User *u);
int do_apology(User *u);
int do_lovenote(User *u);
int do_thankyou(User *u);
int do_tonsil(User *u);
int do_chocolate(User *u);
int do_candy(User *u);
int do_hug(User *u);
int do_admirer(User *u);




int AnopeInit(int argc, char **argv)
{
    Message *msg = NULL;
    int status;
#ifdef IRC_UNREAL32
     msg = createMessage("PRIVMSG", my_privmsg);
    if (UseTokens) {
     msg = createMessage("!", my_privmsg);
    }
#else
    msg = createMessage("PRIVMSG", my_privmsg);
#endif
    status = moduleAddMessage(msg, MOD_HEAD);
    if (status == MOD_ERR_OK) {
        addClient(s_loveserv, "meow!");
        addMessageList();
    }
    moduleAddAuthor(AUTHOR);
    moduleAddVersion(VERSION);
    alog("ircd_loveserv.so: loaded, message status [%d]", status);
    return MOD_CONT;
}

void AnopeFini(void)
{
    delClient();
}

int my_privmsg(char *source, int ac, char **av)
{
    User *u;
    char *s;

    /* First, some basic checks */
    if (ac != 2)
        return MOD_CONT;        /* bleh */
    if (!(u = finduser(source))) {
        return MOD_CONT;
    }                           /* non-user source */
    if (*av[0] == '#') {
        return MOD_CONT;
    }
    /* Channel message */
    /* we should prolly honour the ignore list here, but i cba for this... */
    s = strchr(av[0], '@');
    if (s) {
        *s++ = 0;
        if (stricmp(s, ServerName) != 0)
            return MOD_CONT;
    }
    if ((stricmp(av[0], s_loveserv)) == 0) {     /* its for US! */
        loveserv(u, av[1]);
        return MOD_STOP;
    } else {                    /* ok it isnt us, let the old code have it */
        return MOD_CONT;
    }
}

void addClient(char *nick, char *realname)
{
    anope_cmd_bot_nick(nick, "LoveServ", ServiceHost, "Service d'amour", "+");

}

void delClient(void)
{
    anope_cmd_quit(s_loveserv, "QUIT :Powering Off");
}

void addMessageList(void)
{
    Command *c;
    c = createCommand("about", do_about, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("rose", do_rose, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("kiss", do_kiss, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("tonsil", do_tonsil, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("hug", do_hug, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("admirer", do_admirer, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("chocolate", do_chocolate, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("candy", do_candy, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("lovenote", do_lovenote, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("apology", do_apology, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("thankyou", do_thankyou, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("version", do_version, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
    c = createCommand("help", do_help, NULL, -1, -1, -1, -1, -1);
    moduleAddCommand(loveserv_cmdTable, c, MOD_UNIQUE);
}

/*****************************************************************************/
/* Main loveserv routine. */
void loveserv(User * u, char *buf)
{
    char *cmd, *s;

    cmd = strtok(buf, " ");

    if (!cmd) {
        return;
    } else if (stricmp(cmd, "\1PING") == 0) {
        if (!(s = strtok(NULL, "")))
            s = "\1";
        notice(s_loveserv, u->nick, "\1PING %s", s);
    } else if (skeleton) {
        notice_lang(s_loveserv, u, SERVICE_OFFLINE, s_loveserv);
    } else {
        mod_run_cmd(s_loveserv, u, loveserv_cmdTable, cmd);
    }
}
// about
int do_about(User * u)
{
    notice(s_loveserv, u->nick, "\2LoveServ\2 est un module fun pour montrer que l'on aime quelqu'un sur l'IRC.");
    return MOD_CONT;
}
//rose
int do_rose(User * u)
{
    char *target = strtok(NULL, "");
    if (!target)
        return;
    if (!finduser(target)) {
        notice(s_loveserv, u->nick, "Pas de cible ! Regarde /msg LoveServ HELP");
		return MOD_CONT;
	}
    notice(s_loveserv, u->nick, "Rose envoye  %s!", target);
    notice(s_loveserv, target, "%s t'a envoy une belle rose ! 3--<--<--<{4@", u->nick);
    return MOD_CONT;
}

//kiss
int do_kiss(User * u)
{
    char *target = strtok(NULL, "");
    if (!target)
        return;
    if (!finduser(target)) {
        notice(s_loveserv, u->nick, "Pas de cible ! Regarde /msg LoveServ HELP");
		return MOD_CONT;
	}
    notice(s_loveserv, u->nick, "Vous avez virtuellement embrass %s !", target);
    notice(s_loveserv, target, "%s vous a virtuellement embrass !", u->nick);
    return MOD_CONT;
}
//tonsil
int do_tonsil(User * u)
{
    char *target = strtok(NULL, "");
    if (!target)
        return;
    if (!finduser(target)) {
        notice(s_loveserv, u->nick, "Pas de cible ! Regarde /msg LoveServ HELP");
		return MOD_CONT;
	}
    notice(s_loveserv, u->nick, "Vous avez virtuellement embrass pationement %s!", target);
    notice(s_loveserv, target, "%s te donne un passion, profond, tendre, doux, baiser en passant la main dans tes cheveux... Ah c'est beau l'amour !", u->nick);
    return MOD_CONT;
}
//hug
int do_hug(User * u)
{
    char *target = strtok(NULL, "");
    if (!target)
        return;
    if (!finduser(target)) {
        notice(s_loveserv, u->nick, "Pas de cible ! Regarde /msg LoveServ HELP");
		return MOD_CONT;
	}
    notice(s_loveserv, u->nick, "%s a recu ton calin ! :)", target);
    notice(s_loveserv, target, "%s te fait un gros calin !", u->nick);
    return MOD_CONT;
}
//admirer
int do_admirer(User * u)
{
    char *target = strtok(NULL, "");
    if (!target)
        return;
    if (!finduser(target)) {
        notice(s_loveserv, u->nick, "Pas de cible ! Regarde /msg LoveServ HELP");
		return MOD_CONT;
	}
    notice(s_loveserv, u->nick, "%s sait maintenant qu'il/elle a un admirateur secret ! :)", target);
    notice(s_loveserv, target, "Tu a un admirateur secret ! Non je ne te dirai pas qui c'est ;)");
    return MOD_CONT;
}
//chocolate
int do_chocolate(User * u)
{
    char *target = strtok(NULL, "");
    if (!target)
        return;
    if (!finduser(target)) {
        notice(s_loveserv, u->nick, "Pas de cible ! Regarde /msg LoveServ HELP");
		return MOD_CONT;
	}
    notice(s_loveserv, u->nick, "Votre boit de chocolat a t envoye  %s :)", target);
    notice(s_loveserv, target, "%s t'envoie une enorme boit de chocolat !", u->nick);
    return MOD_CONT;
}
//candy
int do_candy(User * u)
{
    char *target = strtok(NULL, "");
    if (!target)
        return;
    if (!finduser(target)) {
        notice(s_loveserv, u->nick, "Pas de cible ! Regarde /msg LoveServ HELP");
		return MOD_CONT;
	}
    notice(s_loveserv, u->nick, "Un sac de sucreries en forme de coeur a t envoy  %s :)", target);
    notice(s_loveserv, target, "%s t'offre un grand sac de sucreries en forme de coeur ! C'est y pas mignon ?", u->nick);
    return MOD_CONT;
}
//lovenote
int do_lovenote(User * u)
{
    char *target = strtok(NULL, " ");
    char *message = strtok(NULL, "");

    if (!target)
        return;
    if (!finduser(target)) {
        notice(s_loveserv, u->nick, "Pas de cible ! Regarde /msg LoveServ HELP");
		return MOD_CONT;
	}
    notice(s_loveserv, u->nick, "Ta lettre d'amour pour %s a t envoye :)", target);
    notice(s_loveserv, target, "%s t'envoie une lettre d'amour qui dit : \2%s\2", u->nick, message);
    return MOD_CONT;
}
//apology
int do_apology(User * u)
{
    char *target = strtok(NULL, " ");
    char *message = strtok(NULL, "");

    if (!target)
        return;
    if (!finduser(target)) {
        notice(s_loveserv, u->nick, "Pas de cible ! Regarde /msg LoveServ HELP");
		return MOD_CONT;
	}
    notice(s_loveserv, u->nick, "Tes excuses on t envoys  %s", target);
    notice(s_loveserv, target, "%s est dsol, et voudrait faire des excuses pour \2%s\2", u->nick, message);
    return MOD_CONT;
}
//thankyou
int do_thankyou(User * u)
{
    char *target = strtok(NULL, " ");
    char *message = strtok(NULL, "");

    if (!target)
        return;
    if (!finduser(target)) {
        notice(s_loveserv, u->nick, "Pas de cible ! Regarde /msg LoveServ HELP");
		return MOD_CONT;
	}
    notice(s_loveserv, u->nick, "Tes remerciement ont bien t envoys  %s", target);
    notice(s_loveserv, target, "%s te remercie pour \2%s\2", u->nick, message);
    return MOD_CONT;
}
//version
int do_version(User * u)
{
    notice(s_loveserv, u->nick, "\2Informations\2");
    notice(s_loveserv, u->nick, "LoveServ version %s", VERSION);
    notice(s_loveserv, u->nick, "Traduit par [SIMON] <simonledoudou@gmail.com>");
    notice(s_loveserv, u->nick, "Auteur original : Shmad <shmad@neostats.net>");
    return MOD_CONT;
}
//help
int do_help(User *u){
    char *cmd = strtok(NULL, " ");
    if (cmd){
	    if (!stricmp(cmd, "about")){
			notice(s_loveserv, u->nick, "\2LoveServ\2 est un robot d'aide pour ceux qui n'osent pas dire ce qu'ils pensent en face en amour !");
		   return MOD_CONT;
	   }
		if (!stricmp(cmd, "rose")){
			notice(s_loveserv, u->nick, "Syntax: \2ROSE <NICK>\2");
			notice(s_loveserv, u->nick, "");
			notice(s_loveserv, u->nick,	"Envoie une rose  quelqu'un.");
		   return MOD_CONT;
	   }
		if (!stricmp(cmd, "kiss")){
			notice(s_loveserv, u->nick, "Syntax: \2KISS <NICK>\2");
			notice(s_loveserv, u->nick,	"");
			notice(s_loveserv, u->nick,	"Envoie un baiser  quelqu'un.");
		   return MOD_CONT;
	   }
		if (!stricmp(cmd, "tonsil")){
			notice(s_loveserv, u->nick, "Syntax: \2TONSIL <NICK>\2");
			notice(s_loveserv, u->nick,	"");
			notice(s_loveserv, u->nick,	"Envoie un enorme baiser  quelqu'un.");
		   return MOD_CONT;
	   }
		if (!stricmp(cmd, "hug")){
			notice(s_loveserv, u->nick, "Syntax: \2HUG <NICK>\2");
			notice(s_loveserv, u->nick,	"");
			notice(s_loveserv, u->nick,	"Envoie un calin  quelqu'un.");
		   return MOD_CONT;
	   }
		if (!stricmp(cmd, "admirer")){
			notice(s_loveserv, u->nick, "Syntax: \2ADMIRER <NICK>\2");
			notice(s_loveserv, u->nick,	"");
				notice(s_loveserv, u->nick,"Annonce  quelqu'un qu'il a un admirateur secret ( en ne lui disant pas que c'est vous).");
		   return MOD_CONT;
	   }
		if (!stricmp(cmd, "chocolate")){
			notice(s_loveserv, u->nick, "Syntax: \2CHOCOLATE <NICK>\2");
			notice(s_loveserv, u->nick,	"");
			notice(s_loveserv, u->nick,	"Envoie une boite de chocolats  quelqu'un.");
		   return MOD_CONT;
	   }
		if (!stricmp(cmd, "candy")){
			notice(s_loveserv, u->nick, "Syntax: \2CANDY <NICK>\2");
			notice(s_loveserv, u->nick,	"");
			notice(s_loveserv, u->nick,	"Envoie une boite de bonbon en forme de coeur  quelqu'un.");
		   return MOD_CONT;
	   }
		if (!stricmp(cmd, "lovenote")){
			notice(s_loveserv, u->nick, "Syntax: \2LOVENOTE <NICK> <MESSAGE>.\2");
			notice(s_loveserv, u->nick,	"");
			notice(s_loveserv, u->nick,	"Envoie une lettre d'amour  quelqu'un avec le message specifi.");
		   return MOD_CONT;
	   }
		if (!stricmp(cmd, "apology")){
			notice(s_loveserv, u->nick, "Syntax: \2APOLOGY <NICK> <MESSAGE>\2");
			notice(s_loveserv, u->nick,	"");
			notice(s_loveserv, u->nick,	"Envoie un message d'excuse  quelqu'un avec le message specifi.");
		   return MOD_CONT;
	   }
		if (!stricmp(cmd, "thankyou")){
			notice(s_loveserv, u->nick, "Syntax: \2THANKYOU <NICK> <MESSAGE>\2");
				notice(s_loveserv, u->nick,"");
			notice(s_loveserv, u->nick,	"Envoie un message de remerciements  quelqu'un avec le message specifi.");
		   return MOD_CONT;
	   }
		if (!stricmp(cmd, "version")){
			notice(s_loveserv, u->nick, "Syntax: \2VERSION\2");
			notice(s_loveserv, u->nick,	"");
				notice(s_loveserv, u->nick,"Show LoveServ's current version");
		   return MOD_CONT;
	   }
    }

notice(s_loveserv, u->nick, "LoveServ is a fun module to send presents and messages to loved ones on IRC.");
notice(s_loveserv, u->nick, "ROSE Pour donner une rose  quelqu'un");
notice(s_loveserv, u->nick, "KISS pour faire un bisou  quelqu'un");
notice(s_loveserv, u->nick, "TONSIL pour faire un gros bisou  quelqu'un");
notice(s_loveserv, u->nick, "HUG pour faire un calin  quelqu'un");
notice(s_loveserv, u->nick, "ADMIRER pour annoncer  quelqu'un qu'il a un admirateur secret");
notice(s_loveserv, u->nick, "CHOCOLATE pour offrir des chocolats  quelqu'un");
notice(s_loveserv, u->nick, "CANDY pour offrir des bonbons  quelqu'un");
notice(s_loveserv, u->nick, "LOVENOTE pour envoyer un message d'amour  quelqu'un");
notice(s_loveserv, u->nick, "APOLOGY pour s'excuser  quelqu'un");
notice(s_loveserv, u->nick, "THANKYOU pour remercier quelqu'un");

return MOD_CONT;

}